<script setup lang="ts">
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { useMetadataStore } from "@/stores/useMetadataStore";
import { JsonForms } from "@jsonforms/vue";
import { ref, watch } from "vue";

// ----------------------------------------------------------------
// PROPS
// ----------------------------------------------------------------

const props = defineProps({
  solveConflictDialog: {
    type: Boolean,
    required: true,
  },
  currentItem: {
    type: Object,
    required: true,
  },
  objectRelated: {
    type: Object,
    required: true,
  },
  dataAssociationID: {
    type: String,
    required: false,
  },
  ajv: {
    type: Object,
    required: true,
  },
  renderers: {
    type: Array,
    required: true,
  },
});

// ----------------------------------------------------------------
// EMITS
// ----------------------------------------------------------------

const emits = defineEmits(["solveConflictDialog", "newMetadata"]);

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const metadataStore = useMetadataStore();
const drawer = ref<boolean>(false);

const radio = ref<string | null>(null);
const newMetadataValue = ref(null);

// ----------------------------------------------------------------
// Watch
// ----------------------------------------------------------------

watch(
  () => props.solveConflictDialog,
  (newValue) => {
    if (newValue) {
      drawer.value = newValue;
    }
  },
);

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

function close() {
  drawer.value = false;
  radio.value = null;
  newMetadataValue.value = null;
  emits("solveConflictDialog", false);
}

function setRadio(value: any) {
  radio.value = value;
}

function updateNewMetadataValue(value) {
  setRadio("new");
  newMetadataValue.value = value;
}

async function createFieldValue(field, metadataValue, isSelectedValue = false) {
  if (field.schema?.endsWith("api/schemas/taxon?ref=false")) {
    if ("scientificName" in metadataValue && metadataValue.scientificName.includes("::")) {
      metadataValue.scientificName = metadataValue.scientificName.split("::")[1];
    }
  }
  try {
    await metadataStore.createMetadata(
      field.id,
      field.source === "referential" ? "madbot" : "connector",
      metadataValue,
      props.objectRelated.id,
      props.objectRelated.type,
      props.objectRelated.datalinkID || undefined,
      props.dataAssociationID || undefined,
      isSelectedValue,
    );
  } catch (error) {
    console.error("Error creating metadata:", error);
  }
}

async function saveNewValue() {
  if (radio.value === "new" && newMetadataValue.value) {
    await createFieldValue(props.currentItem.field, newMetadataValue.value);
  } else if (radio.value) {
    await createFieldValue(props.currentItem.field, radio.value, true);
  }
  close();
  emits("newMetadata", props.currentItem.field);
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="100%"
    style="max-width: 700px !important; max-height: 800px !important"
    persistent
  >
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet
          class="me-auto"
          style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis"
        >
          Solve conflicts for the metadata: {{ currentItem?.field.name }}
        </v-sheet>
        <v-sheet>
          <v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          />
        </v-sheet>
      </v-card-title>
      <v-card-text>
        <div class="mb-6">
          Select an existing value
          <div class="d-flex flex-column ga-2 py-2" style="max-height: 400px; overflow-x: auto">
            <div
              v-for="item in Object.values(Object.fromEntries(currentItem.values))"
              :key="item.id"
              class="d-flex justify-start"
            >
              <input
                type="radio"
                :checked="radio === item.id"
                :value="item.id"
                class="mr-3"
                @change="radio = $event.target.value"
              >
              <v-card
                class="flex-grow-1"
                link
                @click="setRadio(item.id)"
              >
                <v-card-title>{{ String(item.value) }} </v-card-title>
                <v-card-text>
                  From {{ item.source.object.toLowerCase() }}
                  <em>{{
                    item.source.name.length > 200
                      ? `${item.source.name.substring(0, 200)}...`
                      : item.source.name
                  }}</em>
                </v-card-text>
              </v-card>
            </div>
          </div>
          <!-- If the metadata can be associated with the current object, offer ot set a new value -->
          <div v-if="currentItem.field.relatedTypes.includes(objectRelated.type)">
            <v-divider class="my-4" thickness="3" />
            Or set a new one
            <div class="d-flex justify-center mt-2">
              <input
                type="radio"
                :checked="radio === 'new'"
                value="new"
                @change="radio = $event.target.value"
              >
              <JsonForms
                :data="currentItem.values.values().next().value.value"
                :schema="currentItem?.fieldSchema"
                :renderers="renderers"
                :ajv="ajv"
                @change="(event) => updateNewMetadataValue(event.data)"
                @click="setRadio('new')"
              />
            </div>
          </div>
        </div>

        <v-icon class="info-icon">
          mdi-information-outline
        </v-icon>
        <span class="info-message ml-2">
          This choice is not final. You can choose another value at any time using the menu for this
          metadata.
        </span>
      </v-card-text>
      <v-card-actions>
        <v-spacer />
        <v-btn @click="close">
          Cancel
        </v-btn>
        <v-btn
          color="primary"
          :disabled="radio === null"
          @click="saveNewValue"
        >
          Save
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style>
input[type="radio"] {
  accent-color: #232323;
  cursor: pointer;
}
</style>
